/*
 * init.c
 */

static char *rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/init.c,v 1.1 1994/11/01 03:51:16 tuecke Exp $";

#define PORTS0_DEFINE_GLOBALS

#include "internal.h"

/*
 * ports0_init()
 *
 * Initialize ports0 and return.
 *
 * The modules should be initialized in the following order:
 *	1) machine dependent (md) module
 *	2) thread module
 *	3) protocal modules
 */
void ports0_init(int *argc,
		 char **argv[],
		 char *package_id)
{
    /*
     * This will bootstrap the thread package if necessary, so that
     * basic calls such as printf, malloc, etc can be called.
     */
    _p0_thread_preinit();

    /*
     * Do some global initializations
     */
    _p0_stdout = stdout;

    /*
     * parse the arguments
     */
    _p0_parse_args(argc, argv, package_id);
    
    /*
     * Initialize the threads.
     */
    _p0_thread_init();

} /* ports0_init() */


/*
 * ports0_shutdown()
 *
 * Shutdown Ports0 in this process, and also have it shutdown other
 * processes.
 */
void ports0_shutdown()
{
    _p0_thread_shutdown();
} /* ports0_shutdown() */
