/*
 * macros.h
 *
 * rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/macros.h,v 1.1 1994/11/01 03:51:37 tuecke Exp $"
 */

#ifndef _PORTS0_INCLUDE_MACROS_H
#define _PORTS0_INCLUDE_MACROS_H


#ifdef PORTS0_DEBUG
#define Ports0Debug(Level) (_p0_debug_level >= (Level))
#endif

#ifdef PORTS0_DEBUG
#define ports0_debug_printf(level, message) \
do { \
    if (Ports0Debug(level)) \
    { \
	ports0_printf message; \
    } \
} while (0)
#else
#define ports0_debug_printf(level, message)
#endif

#ifdef PORTS0_MALLOC_DEBUG
#define Ports0MallocDebug(Level) (_p0_malloc_debug_level >= (Level))
#endif

#ifdef PORTS0_DEBUG
#define Ports0BufferMagicCheck(func, buf) \
{ \
    if (*(buf) == (ports0_buffer_t) NULL) \
	ports0_fatal(#func ": NULL ports0_buffer_t\n"); \
    if ((*(buf))->magic != PORTS0_BUFFER_MAGIC) \
	ports0_fatal(#func ": Bad magic number %x on buffer %x\n", \
		    (*(buf))->magic, buf); \
}
#else
#define Ports0BufferMagicCheck(func, buf)
#endif

#endif /* _PORTS0_INCLUDE_MACROS_H */
