/*
 * p0_c_hdr.h
 *
 * rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/p0_c_hdr.h,v 1.1 1994/11/01 03:52:16 tuecke Exp $"
 */

#ifndef _PORTS0_INCLUDE_P0_C_HDR_H
#define _PORTS0_INCLUDE_P0_C_HDR_H

#ifndef MAX_PATH_LENGTH
#define MAX_PATH_LENGTH 1024
#endif /* MAX_PATH_LENGTH */

#ifdef PORTS0_ARCH_S2010
#define PORTS0_DONT_INCLUDE_STRING
#define PORTS0_DONT_INCLUDE_ANSI
EXTERN_C_BEGIN
extern int strlen();
extern char *strcpy();
extern char *strncpy();
extern char *strcat();
extern char *strncat();
extern char *strchr();
extern char *strrchr();
extern void *memcpy();
extern void *memset();
EXTERN_C_END
#endif /* PORTS0_ARCH_S2010 */

#ifndef PORTS0_DONT_INCLUDE_STRING
#include <string.h>
#endif
#ifdef PORTS0_INCLUDE_STRINGS
#include <strings.h>
#endif


#ifndef PORTS0_DONT_INCLUDE_ANSI

#include <stddef.h>
#include <stdlib.h>
#include <errno.h>

#else  /* !PORTS0_DONT_INCLUDE_ANSI */

#ifndef atof
extern double atof();
#endif

#if defined(PORTS0_ARCH_S2010)
#define MALLOC_RETURN char
#else
#define MALLOC_RETURN void
#endif
EXTERN_C_BEGIN
extern void free();
extern MALLOC_RETURN *malloc();
extern MALLOC_RETURN *realloc();
EXTERN_C_END


#ifdef PORTS0_ARCH_SYMMETRY

#include <sys/types.h>

#ifndef NULL
#define NULL ((void *) 0)
#endif

#endif /* PORTS0_ARCH_SYMMETRY */


#endif /* !PORTS0_DONT_INCLUDE_ANSI */


#ifdef PORTS0_ARCH_SYSV
#include <stdio.h>
extern FILE *fdopen();
#endif /* PORTS0_ARCH_SYSV */

/*
 * Some procedure defines to provide for portability...
 */
#ifdef PORTS0_STRCHR_TO_INDEX
#define strchr(S,C)     index(S,C)
#define strrchr(S,C)    rindex(S,C)
#endif

#ifdef PORTS0_MEMCPY_TO_BCOPY
#define memcpy(Dest,Src,Length)		bcopy(Src,Dest,Length)
#endif

#ifdef PORTS0_NO_MEMMOVE
#define memmove(Dest,Src,Length) \
{ \
    char *__Src = ((char *) (Src)); \
    char *__Dest = ((char *) (Dest)); \
    char *__EndSrc = (__Src + (Length)); \
    char *__EndDest = (__Dest + (Length)); \
    if ( (__Src < __Dest) && (__Dest < __EndSrc) ) \
    { \
	/* Overlapping, with __Dest > __Src, so copy from end */ \
	while (__EndSrc > __Src) \
	{ \
	    *(--__EndDest) = *(--__EndSrc); \
	} \
    } \
    else if ( (__Dest < __Src) && (__Src < __EndDest) ) \
    { \
	/* Overlapping, with __Dest < __Src, so copy from beginning */ \
	while (__Src < __EndSrc) \
	{ \
	    *(__Dest++) = *(__Src++); \
	} \
    } \
    else if ( __Src != __Dest ) \
    { \
	/* Non-overlapping (and not the same), so memcpy() can be trusted */ \
	memcpy(Dest,Src,Length); \
    } \
}
#endif /* PORTS0_NO_MEMMOVE */

#ifdef PORTS0_USE_BZERO
#define ZeroOutMemory(Where,Size)	bzero(Where,Size)
#else
#define ZeroOutMemory(Where,Size)	memset(Where,0,Size)
#endif

EXTERN_C_BEGIN
#ifdef PORTS0_GETWD_TO_GETCWD
extern char *getcwd(char *, size_t);
#define getwd(S)	getcwd(S,MAX_PATH_LENGTH)
#else
extern char *getwd( char * );
#endif
EXTERN_C_END

#endif /* _PORTS0_INCLUDE_P0_C_HDR_H */
