
static char *rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/sanity.c,v 1.1 1994/11/01 03:52:29 tuecke Exp $";

#include "internal.h"

void _p0_interrogate_suspect( void *evidence,
			     _p0_structure_types suspect_type, char *caller )
{
    switch( suspect_type ) {
    case _P0_NODE_T:
	break;
    case _P0_CONTEXT_T:
	break;
    case _P0_SEGMENT_T:
	break;
    case _P0_THREAD_T:
	break;
    case _P0_MUTEX_T:
    {
	ports0_mutex_t *m;

	m = (ports0_mutex_t *) evidence;
	if(!_P0_CHECK_START_MAGIC_COOKIE(m))
	{
	    char buf[100];
	    putchar(7);		/* beep */
	    sprintf(buf, "%s: Corrupted mutex (starting cookie = %x)",
		    caller, (unsigned int) _P0_EXTRACT_START_MAGIC_COOKIE(m));
	    _p0_imprison_thread( buf );
	}
	else if(!_P0_CHECK_END_MAGIC_COOKIE(m))
	{
	    char buf[100];
	    sprintf(buf, "%s: Corrupted mutex (ending cookie = %x)",
		    caller, (unsigned int) _P0_EXTRACT_END_MAGIC_COOKIE(m));
	    _p0_imprison_thread( buf );
	}
    }
	break;
    case _P0_COND_T:
    {
	ports0_cond_t *c;

	c = (ports0_cond_t *) evidence;
	if(!_P0_CHECK_START_MAGIC_COOKIE(c))
	{
	    char buf[100];
	    sprintf(buf, "%s: Corrupted condition (starting cookie = %x)",
		    caller, (unsigned int) _P0_EXTRACT_START_MAGIC_COOKIE(c));
	    _p0_imprison_thread( buf );
	}
	else if(!_P0_CHECK_END_MAGIC_COOKIE(c))
	{
	    char buf[100];
	    sprintf(buf, "%s: Corrupted condition (ending cookie = %x)",
		    caller, (unsigned int) _P0_EXTRACT_END_MAGIC_COOKIE(c));
	    _p0_imprison_thread( buf );
	}
	break;
    }
    case _P0_THREAD_FREELIST_T:
	break;
    case _P0_HANDLER_LIST_T:
	break;
    case _P0_HANDLER_RECORD_T:
	break;
    }

}

void _p0_imprison_thread( char *psz_charges )
{
    int dummy_flag;
    int parole=PORTS0_FALSE;

    ports0_printf("Thread Imprisoned:\nCharged with: %s\n", psz_charges );

    while( !parole )
    {
	dummy_flag=0;
    }

    ports0_printf("Thread released on parole\n" );

}
