/*
 * sanity.h
 *
 * rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/sanity.h,v 1.1 1994/11/01 03:52:35 tuecke Exp $"
 */

typedef enum _P0I_structure_types {
  _P0_NODE_T,
  _P0_CONTEXT_T,
  _P0_SEGMENT_T,
  _P0_THREAD_T,
  _P0_MUTEX_T,
  _P0_COND_T,
  _P0_THREAD_FREELIST_T,
  _P0_HANDLER_LIST_T,
  _P0_HANDLER_RECORD_T
} _p0_structure_types;

#define _P0_START_COOKIE_VAL 0x5555
#define _P0_END_COOKIE_VAL   0xaaaa

#ifdef PORTS0_SANITY_CHECK

#define PORTS0_INTERROGATE(mut, code, caller) \
	_p0_interrogate_suspect((void*)mut, code, caller);
#define _P0_START_MAGIC_COOKIE unsigned int _p0_start_magic_cookie;
#define _P0_END_MAGIC_COOKIE   unsigned int _p0_end_magic_cookie;
#define _P0_INIT_START_MAGIC_COOKIE(v1) \
         do {(v1)->_p0_start_magic_cookie=_P0_START_COOKIE_VAL;} while(0)
#define _P0_INIT_END_MAGIC_COOKIE(v1) \
         do {(v1)->_p0_end_magic_cookie=_P0_END_COOKIE_VAL;} while(0)
#define _P0_CHECK_START_MAGIC_COOKIE(tar) \
	((tar)->_p0_start_magic_cookie==_P0_START_COOKIE_VAL)
#define _P0_CHECK_END_MAGIC_COOKIE(tar) \
	((tar)->_p0_end_magic_cookie==_P0_END_COOKIE_VAL)
#define _P0_EXTRACT_START_MAGIC_COOKIE(m) (m)->_p0_start_magic_cookie
#define _P0_EXTRACT_END_MAGIC_COOKIE(m) (m)->_p0_end_magic_cookie

#else

#define PORTS0_INTERROGATE(mut, code, caller) do { int i; i=3; } while(0)
#define _P0_START_MAGIC_COOKIE
#define _P0_END_MAGIC_COOKIE
#define _P0_INIT_START_MAGIC_COOKIE(v1) \
        do { int i; i=3; } while(0)
#define _P0_INIT_END_MAGIC_COOKIE(v1) \
        do { int i; i=3; } while(0)
#define _P0_CHECK_START_MAGIC_COOKIE(tar) 0
#define _P0_CHECK_END_MAGIC_COOKIE(tar) 0
#define _P0_EXTRACT_START_MAGIC_COOKIE(m) 0
#define _P0_EXTRACT_END_MAGIC_COOKIE(m) 0

#endif /* PORTS0_SANITY_CHECK */

void _p0_imprison_thread( char * );
void _p0_interrogate_suspect( void *evidence,
			      _p0_structure_types suspect_type, char *caller );
