/*
 * th_qt_i.h
 *
 * rcsid = "$Header: /Net/bioserv.compbio.caltech.edu/bcomp/src/master/nexus/ports0/th_qt_i.h,v 1.1 1994/11/01 03:53:52 tuecke Exp $"
 */

#define PORTS0_KEY_TABLE_SIZE 16

typedef struct _ports0_thread_name_list_t
{
    char *				name;
    struct _ports0_thread_name_list_t *	next;
} ports0_thread_name_list_t;

typedef struct __p0_thread_t
{
  int         id;
  ports0_thread_name_list_t *    names;
  void *                       key_table_values[PORTS0_KEY_TABLE_SIZE];

  void *                        context;
  ports0_thread_func_t           user_func;
  void *                        user_arg;

  struct __p0_thread_t *        next_free;
} _p0_thread_t;

#define _P0_THREAD_SIZE() \
    (sizeof(_p0_thread_t) + (key_table_size * sizeof(void *)))

/*
 * _p0_thread_id()
 *
 * Set *Thread_ID (int *) to be the thread id of the calling thread.
 */

#define _p0_thread_id(Thread_ID) \
{ \
    _p0_thread_t *__thread; \
    _p0_thread_self(&__thread); \
    *(Thread_ID) = __thread->id; \
}
